#ifndef _BOULDER_H_
#define _BOULDER_H_

#include <vector>
#include "Scene.h"
#include "Player.h"
#include "GameObject.h"
#include "Constants.h"
#include "Material.h"

class Boulder : public Character {
protected:
   bool mEnabled;
   GLUquadricObj *mQuad;
   float mAngle;
   float mCenter[3], mVel[3];
   Material mBoulderMaterial;

   // Texture mapping variable
   static Image *TextureImage;

   void reset();
   void setMaterial();


public:
   Boulder(float posx, float posy, float posz);
   virtual ~Boulder();
   
   void collide(Player *player, double *dx, double *dy, double *dz);
   void collide(std::vector<GameObject *> *objs, double *dx, double *dy, double *dz);
   void decrLife() {}
   void draw();
   void reinitialize();
   void step(double dt, Scene *scene);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif