#ifndef _CAVE_H_
#define _CAVE_H_

#include <iostream>
using namespace std;
#include <cmath>

#include "GameObject.h"
#include "Character.h"
#include "Vector3.h"

class Cave : public GameObject
{
private:
	Vector3 pos;
	float radius;
	float height;

   // Texture mapping variable
   static Image *TextureImage;

public:
	Cave(Vector3 *pTemp, float r, float h)
	{
//      LoadTexture("Stone.bmp", 2);

		pos.x = pTemp->x;
		pos.y = pTemp->y;
		pos.z = pTemp->z;

		mPos[X] = pos.x;
		mPos[Y] = pos.y;
		mPos[Z] = pos.z;

		radius = r;
		height = h;

		// The bounding box of a cylinder in the X direction
		mMax[X] = 0.0f;
		mMax[Y] = 0.0f;
		mMax[Z] = 0.0f;

		mMin[X] = 0.0f;
		mMin[Y] = 0.0f;
		mMin[Z] = 0.0f;
		
		mMax[X] = pos.x + (height/2.0f);
		mMax[Y] = pos.y + radius;
		mMax[Z] = pos.z + radius;

		mMin[X] = pos.x - (height/2.0f);
		mMin[Y] = pos.y - radius;
		mMin[Z] = pos.z - radius;

		cout << "Pos: " << pos.x << " " << pos.y << " " << pos.z << endl;
		cout << "Max: " << mMax[X] << " " << mMax[Y] << " " << mMax[Z] << endl;
		cout << "Min: " << mMin[X] << " " << mMin[Y] << " " << mMin[Z] << endl;
	}

	virtual ~Cave() {

	}

	void draw();
	void step(double dt);
   void reinitialize() {}
	void collide(Character *character, double *dx, double *dy, double *dz);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif