#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_


#include <stdlib.h>
//#include <GL\gl.h>

#if defined(WIN32)   
   /* Windows Systems place glut.h in GL/glut.h */   
#include <windows.h>
   #include <GL\glut.h>
#else                
   /* Apple Systems place glut.h in GLUT/glut.h */
   #include <GLUT/glut.h>
#endif

#if defined(WIN32)
   #include <time.h>
   #define ELAPSED (float)(frameEndTime.tv_usec+1 - frameStartTime.tv_usec)/1.0E3
   #define PASSED (double)(mCurTime.tv_usec+1 - mPrevTime.tv_usec)/1.0E3
   #define TOTAL  (double)(mCurTime.tv_usec+1 - mStartTime.tv_usec)/1.0E3

//   typedef struct timeval {
//        long    tv_sec;         /* seconds */
//        long    tv_usec;        /* and microseconds */
//   } timeval;

   inline void gettimeofday(timeval *t, void *_not_used_) {t->tv_usec = (long)(clock());}
#else
   #include <sys/time.h>
   #define ELAPSED frameEndTime.tv_sec - frameStartTime.tv_sec + \
             ((frameEndTime.tv_usec - frameStartTime.tv_usec)/1.0E6);
   #define PASSED mCurTime.tv_sec - mPrevTime.tv_sec + \
             ((mCurTime.tv_usec - mPrevTime.tv_usec)/1.0E6);
   #define TOTAL mCurTime.tv_sec - mStartTime.tv_sec + \
             ((mCurTime.tv_usec - mStartTime.tv_usec)/1.0E6);
#endif


//#include <GL/gl.h>
//#include <GL/glu.h>

/* Contant Flags */
#define JUMPING      0x01
#define INVINCIBLE   0x02
#define PLAYER       0x04
#define CAMERABEHIND 0x08
#define ORTHO        0x10
#define FALLING      0x20
#define SPACEPRESSED 0x40
#define UPPRESSED    0x80

/* Stage Flags */
#define IMMORTAL      0x01
#define STAGECOMPLETE 0x02
#define STAGELOCK     0x04

// #define BOUNDINGBOXES ?

/* Constant Values */
#define ROOT3 1.7320508075688772935274463415059
#define ROOT2 1.4142135623730950488016887242097
#define PI    3.1415926535897932384626433832795
#define TWOPI 6.283185307179586476925286766559

/* Constant Array Indicies */
#define X 0
#define Y 1
#define Z 2

#define STARTFRAME 0.0f
#define ENDFRAME   100.0f
#define RADIUS     1.0f


/* Constants for Textures */
#define STAGE1BG1   0x01
#define STAGE1BG2   0x02
#define WOODTEX     0x03
#define STONETEX    0x04
#define FIRETEX     0x05
#define CARPETTEX   0x06
#define MODEL1TEX   0x07
#define PARTICLETEX 0x08
#define MOVINGSPIKE 0x09
#define SWNGNGPLTFM 0x0A
#define HORZNTPLFM  0x0B
#define BOULDERTEX  0x0C
#define FALLNGPLFTM 0x0D
#define INSETTEX    0x0E


/* Particle System Constants */
#define MAX_PARTICLES 2000


/*some texture mapping stuff */
typedef struct Image {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
} Image;


#endif