#ifndef _CRUSHING_WALL_H_
#define _CRUSHING_WALL_H_

#include <iostream>
#include <cmath>
#include "GameObject.h"
#include "Character.h"
#include "Vector3.h"

class CrushingWall : public GameObject
{
protected:
   float endPos[3];
   Vector3 trans;
   float currFrame;
   float increment;

   // Texture mapping variable
   static Image *TextureImage;

public:
   CrushingWall(float pX, float pY, float pZ, float endPX, float endPY, float endPZ);
   virtual ~CrushingWall();
   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void linearMotion();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif