#ifndef _FALLINGPLATFORM_H_
#define _FALLINGPLATFORM_H_

#include "GameObject.h"
#include "Character.h"
#include <stdio.h>

class FallingPlatform : public GameObject {
protected:
   bool mEnabled, mFalling;
   float mVel;

   // Texture mapping variable
   static Image *TextureImage;

public:
   FallingPlatform(float minx, float miny, float minz, float maxx, float maxy, float maxz);
   virtual ~FallingPlatform();
   
   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif