#include "FloatingEnemy.h"

FloatingEnemy::FloatingEnemy(float posx, float posy, float posz, float dist) {
   mPos[X] = posx;
   mPos[Y] = posy;
   mPos[Z] = posz;

   mMin[X] = mPos[X] - 0.5f;
   mMin[Y] = mPos[Y] - 0.5f;
   mMin[Z] = mPos[Z] - 0.5f;

   mMax[X] = mPos[X] + 0.5f;
   mMax[Y] = mPos[Y] + 0.5f;
   mMax[Z] = mPos[Z] + 0.5f;

   mEndPos[Y] = mPos[Y];
   mDistance = dist;
   mTime = 0.0f;

   mState = 0;

   mVel[X] = -2.0f;
   mVel[Y] = mVel[Z] = 0.0f;

   myModel = new CMD2Model;
   myModel->Load("models\\ogro\\tris.md2", "models\\ogro\\ogrobase.pcx");
   modelState = MODEL_RUN;
}

FloatingEnemy::~FloatingEnemy() {

}

void FloatingEnemy::draw() {
   if (mEnabled) {
      glPushMatrix();
      glColor3f(1.0, 0.0, 0.0);
      /*drawBoundingBox();
      glBegin(GL_LINES);
         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glVertex3f(mMax[X], mMin[Y], mMax[Z]);

         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);

         glVertex3f(mMax[X], mMin[Y], mMin[Z]);
         glVertex3f(mMin[X], mMin[Y], mMin[Z]);

         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glVertex3f((mMax[X] + mMin[X]) * 0.5f, mMax[Y], (mMax[Z] + mMin[Z]) * 0.5f);

         glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glVertex3f((mMax[X] + mMin[X]) * 0.5f, mMax[Y], (mMax[Z] + mMin[Z]) * 0.5f);

         glVertex3f(mMax[X], mMin[Y], mMin[Z]);
         glVertex3f((mMax[X] + mMin[X]) * 0.5f, mMax[Y], (mMax[Z] + mMin[Z]) * 0.5f);

         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glVertex3f((mMax[X] + mMin[X]) * 0.5f, mMax[Y], (mMax[Z] + mMin[Z]) * 0.5f);
      glEnd();*/

         glTranslatef(mPos[X], mPos[Y], mPos[Z]);
         glScalef(0.025f, 0.025f, 0.025f);
         glTranslatef(0.0f, 5.0f, 0.0f);
         glRotatef(180.0f, 0.f, 1.0, 0.0);
         glRotatef(90.0f, -1, 0, 0);
         glColor3f(1.0, 1.0, 1.0);

         myModel->Animate(67, 73, 0.07f);
      glPopMatrix();
   }
}

void FloatingEnemy::reinitialize() {
   mEnabled = true;
}

void FloatingEnemy::step(double dt, Scene *scene) {
   if (mEnabled) {
      mTime += dt * 2;

      if (mTime > 2 * PI)
         mTime -= 2 * PI;

      mPos[Y] = -1 * sin(mTime) * mDistance + mEndPos[Y];
   
      mMin[Y] = mPos[Y] - 0.5f;
      mMax[Y] = mPos[Y] + 0.5f;

      /*
      this->collide(&scene->mObjects, &dx, &dy, &dz);
      if (scene->mPrevScene)
         this->collide(&scene->mPrevScene->mObjects, &dx, &dy, &dz);   
      if (scene->mNextScene)
         this->collide(&scene->mNextScene->mObjects, &dx, &dy, &dz);
*/
   }
}

void FloatingEnemy::collide(Player *player, double *dx, double *dy, double *dz) {
   if (mEnabled && collideAxis(player, X) && collideAxis(player, Y) && 
    collideAxis(player, Z)) {
      if (player->mPos[Y] >= mMax[Y]) {                                          
         player->mState &= ~JUMPING;                                             
         player->forceJump();
         mEnabled = false;

         if (!(player->mState & SPACEPRESSED))
            player->stopJump();
      }             
      else 
         player->decrLife();
   }
}

void FloatingEnemy::collide(std::vector<GameObject *> *objs, double *dx, double *dy, double *dz) {
   for (std::vector<GameObject *>::iterator itr = objs->begin(); itr != objs->end(); itr++) {
      (*itr)->collide(this, dx, dy, dz);
   }
}
