#ifndef _FLOATINGENEMY_H_
#define _FLOATINGENEMY_H_

/*
FloatingEnemy.h

Floating enemies float vertically similar to a moving platform.

PROGRAMMER NOTES:
Should their destruction cause them to fall? That could be kinda
cool, especially since none are over platforms, so there'd be no
need to let them land. However, they'll have to be able to
land and turn into walking enemies if we decide to make the game
customizable.
-STL

*/

#include <vector>
#include <math.h>
#include "Scene.h"
//#include "Character.h"
#include "Player.h"
#include "Constants.h"

class FloatingEnemy : public Character {
protected:
   bool mEnabled;
   float mAngle,  mTime,  mDistance;
   float mEndPos[3];

   CMD2Model *myModel;		// the character model
   modelState_t modelState;		// global model state

public:
   FloatingEnemy(float posx, float posy, float posz, float dist);
   virtual ~FloatingEnemy();

   void collide(Player *player, double *dx, double *dy, double *dz);
   void collide(std::vector<GameObject *> *objs, double *dx, double *dy, double *dz);
   void decrLife() {}
   void draw();
   void reinitialize();
   void step(double dt, Scene *scene);

};

#endif
