#include "GameObject.h"
#include "Character.h"


 bool GameObject::collideAxis(Character *character, int axis) {
   return character->mMax[axis] > mMin[axis] && 
    character->mMin[axis] < mMax[axis];

//    (character->mMin[axis] > mMin[axis] && character->mMin[axis] < mMax[axis]) ||
//    (character->mMax[axis] > mMin[axis] && character->mMax[axis] < mMax[axis]) ||
//    (mMin[axis] > character->mMin[axis] && mMin[axis] < character->mMax[axis]) ||
//    (mMax[axis] > character->mMin[axis] && mMax[axis] < character->mMax[axis]);   
}

 bool GameObject::collideAxis(Character *character, int axis, double *offset) {
   return character->mMax[axis] + *offset > mMin[axis] && 
    character->mMin[axis] + *offset < mMax[axis];

//    (character->mMin[axis] + *offset > mMin[axis] && character->mMin[axis] + *offset < mMax[axis]) ||
//    (character->mMax[axis] + *offset > mMin[axis] && character->mMax[axis] + *offset < mMax[axis]) ||
//    (mMin[axis] > character->mMin[axis] + *offset && mMin[axis] < character->mMax[axis] + *offset) ||
//    (mMax[axis] > character->mMin[axis] + *offset && mMax[axis] < character->mMax[axis] + *offset);   
}


void GameObject::drawBoundingBox() {
   glBegin(GL_LINES);
      glVertex3f(mMin[X], mMin[Y], mMin[Z]);
      glVertex3f(mMax[X], mMin[Y], mMin[Z]);

      glVertex3f(mMin[X], mMin[Y], mMin[Z]);
      glVertex3f(mMin[X], mMax[Y], mMin[Z]);

      glVertex3f(mMin[X], mMin[Y], mMin[Z]);
      glVertex3f(mMin[X], mMin[Y], mMax[Z]);

      glVertex3f(mMax[X], mMax[Y], mMin[Z]);
      glVertex3f(mMin[X], mMax[Y], mMin[Z]);

      glVertex3f(mMax[X], mMax[Y], mMin[Z]);
      glVertex3f(mMax[X], mMax[Y], mMax[Z]);

      glVertex3f(mMax[X], mMax[Y], mMin[Z]);
      glVertex3f(mMax[X], mMin[Y], mMin[Z]);

      glVertex3f(mMax[X], mMin[Y], mMax[Z]);
      glVertex3f(mMax[X], mMin[Y], mMin[Z]);

      glVertex3f(mMax[X], mMin[Y], mMax[Z]);
      glVertex3f(mMax[X], mMax[Y], mMax[Z]);

      glVertex3f(mMax[X], mMin[Y], mMax[Z]);
      glVertex3f(mMin[X], mMin[Y], mMax[Z]);

      glVertex3f(mMin[X], mMax[Y], mMax[Z]);
      glVertex3f(mMin[X], mMin[Y], mMax[Z]);

      glVertex3f(mMin[X], mMax[Y], mMax[Z]);
      glVertex3f(mMin[X], mMax[Y], mMin[Z]);

      glVertex3f(mMin[X], mMax[Y], mMax[Z]);
      glVertex3f(mMax[X], mMax[Y], mMax[Z]);
   glEnd();
}

void GameObject::drawFaces(int idNum, bool minFaceX, bool maxFaceX)
{
   glPushMatrix();
      glEnable(GL_TEXTURE_2D);
      if(minFaceX)
      {
         // xMin
         glBindTexture(GL_TEXTURE_2D, idNum);
         glBegin(GL_POLYGON);
            glTexCoord2f(0.0f, 0.0f);
            glVertex3f(mMin[X], mMin[Y], mMin[Z]);
            glTexCoord2f(0.0f, 1.0f);
            glVertex3f(mMin[X], mMin[Y], mMax[Z]);
            glTexCoord2f(1.0f, 1.0f);
            glVertex3f(mMin[X], mMax[Y], mMax[Z]);
            glTexCoord2f(1.0f, 0.0f);
            glVertex3f(mMin[X], mMax[Y], mMin[Z]);
         glEnd();
      }
      if(maxFaceX)
      {
         // xMax
         glBindTexture(GL_TEXTURE_2D, idNum);
         glBegin(GL_POLYGON);
            glTexCoord2f(0.0f, 0.0f);
            glVertex3f(mMax[X], mMin[Y], mMax[Z]);
            glTexCoord2f(0.0f, 1.0f);
            glVertex3f(mMax[X], mMin[Y], mMin[Z]);
            glTexCoord2f(1.0f, 1.0f);
            glVertex3f(mMax[X], mMax[Y], mMin[Z]);
            glTexCoord2f(1.0f, 0.0f);
            glVertex3f(mMax[X], mMax[Y], mMax[Z]);
         glEnd();
      }
      // yMin
      glBindTexture(GL_TEXTURE_2D, idNum);
      glBegin(GL_POLYGON);
         glTexCoord2f(0.0f, 0.0f);
         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glTexCoord2f(0.0f, 1.0f);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glTexCoord2f(1.0f, 1.0f);
         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glTexCoord2f(1.0f, 0.0f);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);
      glEnd();
      // yMax
      glBindTexture(GL_TEXTURE_2D, idNum);
      glBegin(GL_POLYGON);
         glTexCoord2f(0.0f, 0.0f);
         glVertex3f(mMin[X], mMax[Y], mMin[Z]);
         glTexCoord2f(0.0f, 1.0f);
         glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glTexCoord2f(1.0f, 1.0f);
         glVertex3f(mMax[X], mMax[Y], mMax[Z]);
         glTexCoord2f(1.0f, 0.0f);
         glVertex3f(mMax[X], mMax[Y], mMin[Z]);
      glEnd();
      // zMin
      glBindTexture(GL_TEXTURE_2D, idNum);
      glBegin(GL_POLYGON);
         glTexCoord2f(0.0f, 0.0f);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);
         glTexCoord2f(0.0f, 1.0f);
         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glTexCoord2f(1.0f, 1.0f);
         glVertex3f(mMin[X], mMax[Y], mMin[Z]);
         glTexCoord2f(1.0f, 0.0f);
         glVertex3f(mMax[X], mMax[Y], mMin[Z]);
      glEnd();
      // zMax
      glBindTexture(GL_TEXTURE_2D, idNum);
      glBegin(GL_POLYGON);
         glTexCoord2f(0.0f, 0.0f);
         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glTexCoord2f(0.0f, 1.0f);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glTexCoord2f(1.0f, 1.0f);
         glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glTexCoord2f(1.0f, 0.0f);
         glVertex3f(mMax[X], mMax[Y], mMax[Z]);
      glEnd();
      glDisable(GL_TEXTURE_2D);
   glPopMatrix();
}