#ifndef _GAMEOBJECT_H_
#define _GAMEOBJECT_H_

#include <iostream>
#include <cmath>
using namespace std;

#include "Vector3.h"
#include "Constants.h"

class Character;

class GameObject {
friend class Ground;
friend class Platform;
friend class Stage1;

protected:
   float mPos[3];
   float mMin[3], mMax[3];
   bool mEnabled;

   bool collideAxis(Character *character, int axis);
   bool collideAxis(Character *character, int axis, double *offset);
   void drawBoundingBox();

public:
   GameObject() {}
   virtual ~GameObject() {}

   virtual void collide(Character *character, double *dx, double *dy, double *dz) = 0;
   virtual void draw() = 0;
   virtual void reinitialize() = 0;
   virtual void step(double dt) = 0;
   void drawFaces(int idNum, bool minFaceX = true, bool maxFaceX = true);
};

#endif