#ifndef _GROUND_H_
#define _GROUND_H_

#include <iostream>
#include <cmath>
using namespace std;

#include "GameObject.h"
#include "Character.h"
#include "Vector3.h"

class Ground : public GameObject {
private:
   float currFrame;
   float increment;
   float angle;

   // Texture mapping variable
   static Image *TextureImage;

public:
   Ground(float minx, float miny, float minz, float maxx, float maxy, float maxz) {
      mMin[X] = minx;
      mMin[Y] = miny;
      mMin[Z] = minz;

      mMax[X] = maxx;
      mMax[Y] = maxy;
      mMax[Z] = maxz;
   };

   virtual ~Ground() {}

   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif