#ifndef _HORIZONTALPLATFORM_H_
#define _HORIZONTALPLATFORM_H_

#include "GameObject.h"
#include "Character.h"

class HorizontalPlatform : public GameObject {
protected:
   float mEndPos[3];
   float mThick[3];
   float mDistance;
   float mAngle;
   float mTime;
   float mPlayerPrev;
   char mAxis;

   // Texture mapping variable
   static Image *TextureImage;

public:
   HorizontalPlatform(float centerx, float centery, float centerz,
                      float width, float height, float depth, float distance, char axis);
   virtual ~HorizontalPlatform();
   
   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif