#ifndef _INSET_H_
#define _INSET_H_

#include "GameObject.h"
#include "Character.h"

/******************************************************************************
Inset.h

An inset is a box slightly offset from the stage on the Z axis. It's purpose
is for the player to temporarily hide in it in order to avoid hazards such
as boulders or enemies.
******************************************************************************/
class Inset : public GameObject {
protected:
   // Texture mapping variable
   static Image *TextureImage;

public:
   Inset(float minx, float miny, float maxx, float maxy);
   virtual ~Inset();
   
   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif