#ifndef _MOVING_SPIJE_H_
#define _MOVING_SPIKE_H_

#include "GameObject.h"
#include "Character.h"
#include "Constants.h"
#include "Vector3.h"

class MovingSpike : public GameObject
{
private:
	Vector3 startPos, endPos;
   Vector3 trans;    /* Keeps track of transformations between interpolation */
   float currFrame;
   float increment;

   // Texture mapping variable
   static Image *TextureImage;

public:
	MovingSpike(Vector3 *s, Vector3 *e)
	{
      currFrame = STARTFRAME;
      increment = 0.5f;

      startPos.x = s->x;
		startPos.y = s->y;
		startPos.z = s->z;

		endPos.x = e->x;
		endPos.y = e->y;
		endPos.z = e->z;

      trans.x = 0.0f;
      trans.y = 0.0f;
      trans.z = 0.0f;

		mPos[X] = startPos.x;
		mPos[Y] = startPos.y;
		mPos[Z] = startPos.z;

		mMin[X] = mPos[X] - 0.25f;
		mMin[Y] = mPos[Y] - 0.0f;
		mMin[Z] = mPos[Z] - 0.25f;

		mMax[X] = mPos[X] + 0.25f;
		mMax[Y] = mPos[Y] + 3.0f;
		mMax[Z] = mPos[Z] + 0.25f;
	}
	virtual ~MovingSpike()
	{

	}
	void draw();
   void reinitialize() {}
	void step(double dt);
	void collide(Character *character, double *dx, double *dy, double *dz);
   void linearMotion();
   
   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};
#endif