#ifndef _PARTICLESYSTEM_H_
#define _PARTICLESYSTEM_H_

#include <stdio.h>
#include "Particle.h"

#include "Character.h"
#include "GameObject.h"

// A Structure For RGB Bitmaps
typedef struct _RGBIMG {
	GLuint   w;    // Image's Width
	GLuint   h;    // Image's Height
	GLubyte* data; // Image's Data (Pixels)
} RGBIMG;

class ParticleSystem : public GameObject {
private:
   float mSize;
   Particle *mParticles;

public:
   ParticleSystem(float, float, float, float, float, float, float size);
   virtual ~ParticleSystem();

   void collide(Character *, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

//   static AUX_RGBImageRec *LoadBMP(char *fname);
//   static int LoadGLTextures();
   static bool setup_textures();
   static float Colors[9][3];
   static unsigned int texture[1];
};

#endif
