#ifndef _PIT_H_
#define _PIT_H_

#include <iostream>
using namespace std;
#include <cmath>

#include "GameObject.h"
#include "Character.h"
#include "Vector3.h"

class Pit : public GameObject
{
private:
	Vector3 pos;
	float outerRadius;
	float innerRadius;
	float height;
	float innerMax[3];
	float innerMin[3];

   // Texture mapping variable
   static Image *TextureImage;

   static GLuint texture[1];
public:
	Pit(Vector3 *pTemp, float outerR, float innerR, float length)
	{
//      LoadTexture("Stone.bmp", 4);
//      LoadTexture("Fire.bmp", 5);

		pos.x = pTemp->x;
		pos.y = pTemp->y;
		pos.z = pTemp->z;

		outerRadius = outerR;
		innerRadius = innerR;
		height = length;

		// The bounding box of a cylinder in the X direction
		mMax[X] = 0.0f;
		mMax[Y] = 0.0f;
		mMax[Z] = 0.0f;

		mMin[X] = 0.0f;
		mMin[Y] = 0.0f;
		mMin[Z] = 0.0f;

		innerMax[X] = 0.0f;
		innerMax[Y] = 0.0f;
		innerMax[Z] = 0.0f;

		innerMin[X] = 0.0f;
		innerMin[Y] = 0.0f;
		innerMin[Z] = 0.0f;
		
		mMax[X] = pos.x + (height/2.0f);
		mMax[Y] = pos.y + outerRadius;
		mMax[Z] = pos.z + outerRadius;

		mMin[X] = pos.x - (height/2.0f);
		mMin[Y] = pos.y - outerRadius;
		mMin[Z] = pos.z - outerRadius;

		innerMax[X] = mMax[X];
		innerMax[Y] = pos.y + innerRadius;
		innerMax[Z] = pos.z + innerRadius;

		innerMin[X] = mMin[X];
		innerMin[Y] = pos.y - innerRadius;
		innerMin[Z] = pos.z - innerRadius;
	}
	virtual ~Pit() {

	}
	void draw();
   void reinitialize() {}
	void step(double dt);
	void collide(Character *character, double *dx, double *dy, double *dz);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif