#include "Platform.h"

void Platform::draw() {
   glPushMatrix();
      glColor3f(0.0, 1.0, 0.0);

      switch(grndActn)
      {
         case PENDULUM:
            glTranslatef(0.0f, RADIUS/2, 0.0f);
            glRotatef(angle, 1.0f, 0.0f, 0.0f);
            //glTranslatef(trans.x, trans.y, trans.z);
            break;
//         case LINEAR:
//            glTranslatef(trans.x, trans.y, trans.z);
//            break;
         case SPIRAL:
            glTranslatef(pos.x, pos.y, pos.z);
            glRotatef(angle, 0.0f, 0.0f, 1.0f);
            glTranslatef(-pos.x, -pos.y, -pos.z);
         default:
            break;
      }
      glEnable(GL_LIGHTING);
      glShadeModel(GL_SMOOTH);
      glBegin(GL_QUADS);
         // BACK FACE
         glNormal3f( -1.0f,   0.0f,   0.0f); glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glNormal3f( -1.0f,   0.0f,   0.0f); glVertex3f(mMax[X], mMin[Y], mMin[Z]);
         glNormal3f( -1.0f,   0.0f,   0.0f); glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glNormal3f( -1.0f,   0.0f,   0.0f); glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         // FRONT FACE
         glNormal3f(  1.0f,   0.0f,   0.0f); glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glNormal3f(  1.0f,   0.0f,   0.0f); glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glNormal3f(  1.0f,   0.0f,   0.0f); glVertex3f(mMax[X], mMax[Y], mMax[Z]);
         glNormal3f(  1.0f,   0.0f,   0.0f); glVertex3f(mMin[X], mMax[Y], mMax[Z]);
   
         // RIGHT FACE
         glNormal3f( ROOT2, -ROOT2,   0.0f); glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glNormal3f( ROOT2, -ROOT2,   0.0f); glVertex3f(mMax[X], mMin[Y], mMin[Z]);
         glNormal3f( ROOT2,  ROOT2,   0.0f); glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glNormal3f( ROOT2,  ROOT2,   0.0f); glVertex3f(mMax[X], mMax[Y], mMax[Z]);

         // LEFT FACE
         glNormal3f(-ROOT2, -ROOT2,   0.0f); glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glNormal3f(-ROOT2, -ROOT2,   0.0f); glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glNormal3f(-ROOT2,  ROOT2,   0.0f); glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glNormal3f(-ROOT2,  ROOT2,   0.0f); glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         // TOP FACE
         glNormal3f(-ROOT2, -ROOT2,  0.0f); glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glNormal3f( ROOT2, -ROOT2,  0.0f); glVertex3f(mMax[X], mMax[Y], mMax[Z]);
         glNormal3f( ROOT2,  ROOT2,  0.0f); glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glNormal3f(-ROOT2,  ROOT2,  0.0f); glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         // BOTTOM FACE
         glNormal3f(-ROOT2, -ROOT2,  0.0f); glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glNormal3f(-ROOT2, -ROOT2,  0.0f); glVertex3f(mMin[X], mMin[Y], mMax[Z]);
         glNormal3f( ROOT2, -ROOT2,  0.0f); glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glNormal3f( ROOT2, -ROOT2,  0.0f); glVertex3f(mMax[X], mMin[Y], mMin[Z]);

      glEnd();
      glDisable(GL_LIGHTING);

/*
      glBegin(GL_LINES);
         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);

         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         glVertex3f(mMin[X], mMin[Y], mMin[Z]);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);

         glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glVertex3f(mMax[X], mMax[Y], mMax[Z]);

         glVertex3f(mMax[X], mMax[Y], mMin[Z]);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);

         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glVertex3f(mMax[X], mMin[Y], mMin[Z]);

         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glVertex3f(mMax[X], mMax[Y], mMax[Z]);

         glVertex3f(mMax[X], mMin[Y], mMax[Z]);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);

         glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glVertex3f(mMin[X], mMin[Y], mMax[Z]);

         glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glVertex3f(mMin[X], mMax[Y], mMin[Z]);

         glVertex3f(mMin[X], mMax[Y], mMax[Z]);
         glVertex3f(mMax[X], mMax[Y], mMax[Z]);
      glEnd();
 */
   glPopMatrix();
}

void Platform::setEndPosition(Vector3 *v){
   endPos.x = v->x;
   endPos.y = v->y;
   endPos.z = v->z;
}

/*
 * Performs linear interpolation between the start and end point.
 */
void Platform::linearMotion(){
   float t = (currFrame - STARTFRAME) / (ENDFRAME - STARTFRAME);

   mMin[X] += t * (endPos.x - pos.x) - trans.x;
   mMax[X] += t * (endPos.x - pos.x) - trans.x;
   mMin[Y] += t * (endPos.y - pos.y) - trans.y;
   mMax[Y] += t * (endPos.y - pos.y) - trans.y;
   mMin[Z] += t * (endPos.z - pos.z) - trans.z;
   mMax[Z] += t * (endPos.z - pos.z) - trans.z;

   trans.x =  t*(endPos.x - pos.x);
   trans.y =  t*(endPos.y - pos.y);
   trans.z =  t*(endPos.z - pos.z);
}

/*
 * Performs a rotational motion between -90 and 90 degrees.
 */
void Platform::PendulumMotion(){

   /* variable t can only have a range between [0.0, 1.0] */
   float t = (currFrame - STARTFRAME) / (ENDFRAME - STARTFRAME);
   float A = 1.0f;   /* Amplitude */
   float w = 1.0f;   /* Angular velocity */

   float phi = t * 2 * PI;   /* Convert t to radians */
   angle = (180.0f * phi) / (2.0f * PI) + 90;

   cout << "t = " << t << "\tangle = " << phi << endl;

   /* x = Acos(w*phi) */
   float x = A * (float)cos(w * phi);
   /* y = sqrt(r^2 - x^2) */
   float y = sqrt(RADIUS*RADIUS - x*x);

   //trans.x = x;
   //trans.y = y;
   //trans.z = 0.0f;
}

void Platform::spiralMotion(){
   float t = (currFrame - STARTFRAME) / (ENDFRAME - STARTFRAME);
   float phi = t * 2 * PI;   /* Convert t to radians */
   angle = (180.0f * phi) / (2.0f * PI) + 90;
}

void Platform::step(double dt) {

   switch(grndActn)
   {
      case NONE:
         break;
      case PENDULUM:
         PendulumMotion();
         break;
      case LINEAR:
         linearMotion();
         break;
      case SPIRAL:
         spiralMotion();
      default:
         break;
   }

   currFrame += increment;

   /* keeps t between [0, 1] */
   if(currFrame == ENDFRAME)
      increment = -1;
   if(currFrame == STARTFRAME)
      increment = 1;
}

void Platform::collide(Character *character, double *dx, double *dy, double *dz) {
   if ((character->mMin[X] + *dx >= mMin[X] && character->mMin[X] + *dx <= mMax[X]) ||
       (character->mMax[X] + *dx >= mMin[X] && character->mMax[X] + *dx <= mMax[X]) ||
       (character->mMin[X] + *dx <= mMin[X] && character->mMax[X] + *dx >= mMin[X]) ||
       (character->mMin[X] + *dx <= mMax[X] && character->mMax[X] + *dx >= mMax[X])) {

      if ((character->mMin[Y] + *dy >= mMin[Y] && character->mMin[Y] + *dy <= mMax[Y]) || 
       (character->mMax[Y] + *dy >= mMin[Y] && character->mMax[Y] + *dy <= mMax[Y]) ||
       (character->mMin[Y] + *dy <= mMax[Y] && character->mMax[Y] + *dy >= mMax[Y]) ||
       (character->mMin[Y] + *dy <= mMin[Y] && character->mMax[Y] + *dy >= mMin[Y])) {
            // intersection with y
                
         if (character->mPos[Y] > mMax[Y]) {                                          // character is above platform
            character->mState &= ~JUMPING;                                             // character has landed from a jump
            *dy = mMax[Y] - character->mMin[Y] + 0.01f;
            character->mVel[Y] = 0;
         }
         else {                             // character collided with bottom of platform
            if (character->mVel[Y] > 0) {   // if velocity is positive, stop going up
               *dy = mMin[Y] - character->mMax[Y] - 0.01f; 
               character->mVel[Y] = 0;
            }
         }
      }
   }

   // if dx causes collsion
   if ((character->mMin[X] + *dx >= mMin[X] && character->mMin[X] + *dx <= mMax[X]) ||           // character's left plane intersects object
       (character->mMax[X] + *dx >= mMin[X] && character->mMax[X] + *dx <= mMax[X]) ||           // character's right plane intersects object
       (character->mMin[X] + *dx <= mMin[X] && character->mMax[X] + *dx >= mMin[X]) ||           // object's left plane intersects character
       (character->mMin[X] + *dx <= mMax[X] && character->mMax[X] + *dx >= mMax[X])) {           // object's right plane intersects character
      if ((character->mMin[Y] + *dy >= mMin[Y] && character->mMin[Y] + *dy <= mMax[Y]) || 
       (character->mMax[Y] + *dy >= mMin[Y] && character->mMax[Y] + *dy <= mMax[Y]) ||
       (character->mMin[Y] + *dy <= mMin[Y] && character->mMax[Y] + *dy >= mMin[Y]) ||
       (character->mMin[Y] + *dy <= mMax[Y] && character->mMax[Y] + *dy >= mMax[Y])) {

         if (character->mPos[X] > mMax[X]) {                                         // character intersected right plane          
            *dx = mMax[X] - character->mMin[X] + 0.01f;
         }
         else
            *dx = mMin[X] - character->mMax[X] - 0.01f;

         character->mVel[X] = 0;
      }
   }
}