#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <math.h>
#include <vector>
#include "Vector3.h"
#include "Scene.h"
//#include "Character.h"
#include "GameObject.h"
#include "Constants.h"

#include "md2.h"


class GameObject;
class Scene;

class Player : public Character {
friend class ParticleSystem;
friend class Ground;
friend class Platform;
friend class Stage1;
friend class Stage2;

protected:
   GLUquadricObj *mQuad;
   double mJumpTime;
   unsigned char mLives;

   CMD2Model *myModel;		// the character model
   modelState_t modelState;		// global model state


public:
   Player();
   virtual ~Player();

   void collide(Player *player, double *dx, double *dy, double *dz) {}
   void collide(std::vector<Character *> *foes, double *dx, double *dy, double *dz);
   void collide(std::vector<GameObject *> *objs, double *dx, double *dy, double *dz);
   void decrLife();
   void draw();
   void reinitialize();
   void step(double dt, Scene *scene);

   void jump();
   void stopJump();
   void forceJump();

   inline float getLife() {return mLife;}
};

#endif