#include "Scene.h"

Scene::Scene(float offset) : mOffset(offset), mPrevScene(0), mNextScene(0) {}

Scene::~Scene() {
   if (mNextScene)   // this line may not be needed 
      delete mNextScene;
}

void Scene::addObject(GameObject *obj) {
   mObjects.push_back(obj);
}

void Scene::addCharacter(Character *character) {
   mFoes.push_back(character);
}

void Scene::draw() {
   for (std::vector<Character *>::iterator itr = mFoes.begin(); itr != mFoes.end(); itr++) {
      (*itr)->draw();
   }

   for (std::vector<GameObject *>::iterator itr = mObjects.begin(); itr != mObjects.end(); itr++) {
      (*itr)->draw();
   }
}

void Scene::step(double dt) {
   for (std::vector<Character *>::iterator itr = mFoes.begin(); itr != mFoes.end(); itr++) {
      (*itr)->step(dt, this);
   }

   for (std::vector<GameObject *>::iterator itr = mObjects.begin(); itr != mObjects.end(); itr++) {
      (*itr)->step(dt);
   }
}