#ifndef _SCENE_H_
#define _SCENE_H_

#include <vector>
#include "GameObject.h"
#include "Constants.h"
#include "Character.h"

#define SCENE_WIDTH 10.0f
#define SCENE_HEIGHT 6.0f

class Scene {
friend class Stage1;
friend class Stage2;
friend class Boulder;
friend class Player;
friend class WalkingEnemy;
friend class PacingEnemy;
friend class FloatingEnemy;

protected:
   float mOffset;
   Scene *mPrevScene, *mNextScene;
   std::vector<GameObject *> mObjects;
   std::vector<Character *> mFoes;

public:
   Scene(float offset);
   virtual ~Scene();

   void addObject(GameObject *obj);
   void addCharacter(Character *character);

   void draw();
   void step(double dt);
//   void reset();
};

#endif