#ifndef _STAGE1_H_
#define _STAGE1_H_

#include <stdio.h>

#include "Stage.h"
#include "Scene.h"
#include "MusicBox.h"

#include "Player.h"
#include "Camera.h"
#include "Coin.h"

#include "Boulder.h"
#include "Ground.h"
#include "Inset.h"
#include "FallingPlatform.h"
#include "HorizontalPlatform.h"
#include "SwingingPlatform.h"

#include "ParticleSystem.h"
#include "FlowSystem.h"

#include "WalkingEnemy.h"
#include "FloatingEnemy.h"
#include "PacingEnemy.h"

#include "Constants.h"

class Stage1 : public Stage {
private:
   struct timeval mPrevTime, mCurTime, mStartTime;
   struct timeval frameStartTime, frameEndTime;

//   Player *mPlayer;
   Camera *mCamera;
   Scene *mCurScene, *mFirstScene;

   unsigned char mCurKey;
   int mCurSpecial;
   Image *mBG1, *mBG2;
   MusicBox *mMusic;

   GLvoid LoadTextures();
   unsigned int getint(FILE *fp);
   unsigned int getshort(FILE *fp);
   int ImageLoad(char *filename, Image *image);

public:
   Stage1();
   virtual ~Stage1();

   void display();
   void idle();
   void keyboard(unsigned char key, int x, int y);
   void keyboardUp(unsigned char key, int x, int y);
   void reshape(int x, int y);
   void special(int key, int x, int y);
   void specialUp(int key, int x, int y);

   void initScenes();
   void initStage() {}
   void restartStage();

   inline void frameStart() {gettimeofday(&frameStartTime, NULL);}
   void frameEnd(void *font, GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y);
};

#endif