#include "Stage2.h"
#include "World.h"

#define EOSSTAGE2 165.0f

int World::wWidth;
int World::wHeight;

Stage2::Stage2()
{
	if (!ParticleSystem::setup_textures())
		printf("Error reading textures\n");

//	Stage::mPlayer = new Player();
	//Stage::mPlayer.mState ^= CAMERABEHIND;	// Set to back-Stage::mPlayer.

	mCamera = new Camera();
	mCurKey = mCurSpecial = 0;
	mStageFlags = 0;

	//testEnemy = new WalkingEnemy(10.0f, 1.0f, -1.0f);
	//testBoulder = new Boulder(10.0f, 5.0f, 2.0f);

	initScenes();
}

/* Destructor - Does nothing */
Stage2::~Stage2()
{

}

/* This is where I will design my levels */
void Stage2::initScenes()
{
   float curOffset = 0.0f;

   // SCENE 1
   mFirstScene = mCurScene = new Scene(curOffset);
   Vector3 *v = new Vector3(curOffset + 0.0f, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
                                    5.0f + curOffset,  0.0f,  4.0f));
   mCurScene->addObject(new Coin(4.5f + curOffset, 0.75f, 0.0f));
   mCurScene->addObject(new Coin(3.5f + curOffset, 0.75f, 0.0f));
   mCurScene->addObject(new Coin(2.5f + curOffset, 0.75f, 0.0f));

   mCurScene->addCharacter(new WalkingEnemy(5.0f, 0.5f, 0.0f));
   //----------------------------------------------------------------------


   // SCENE 2
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;
   
   v = new Vector3(curOffset + 0.0f, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
                                    5.0f + curOffset,  0.0f,  4.0f));
   mCurScene->addObject(new Ground(-3.8f + curOffset,  2.5f, -1.0f,
                                   -1.0f + curOffset,  3.0f,  2.0f));
                                   
   mCurScene->addObject(new Coin(-3.0f + curOffset, 0.75f, -1.5f));
   mCurScene->addObject(new Coin(-3.0f + curOffset, 0.75f, 0.0f));
   mCurScene->addObject(new Coin(-3.0f + curOffset, 0.75f, 1.5f));

   mCurScene->addObject(new ParticleSystem(-4.1f + curOffset, 0.0f, -1.5f,
                                           -3.7f + curOffset, 0.25f,  1.5f, 2000));
   mCurScene->addCharacter(new WalkingEnemy(curOffset + 2.5f, 0.5f, -2.0f));
   mCurScene->addCharacter(new WalkingEnemy(curOffset + 1.25f, 0.5f, 2.0f));
   //----------------------------------------------------------------------


   // Scene 3 - NEED 2 PACING ENEMIES.
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset + 0.0f, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
                                    5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 3.0f));
   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 2.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 3.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 2.0f));

   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -3.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -2.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -3.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -2.0f));

   mCurScene->addCharacter(new Boulder(-3.2f + curOffset, 5.0f, -1.5f));
   mCurScene->addCharacter(new Boulder(2.6f + curOffset, 5.0f, 1.6f));
   //----------------------------------------------------------------------

   
	// Scene 4 - PIT SCENE
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									15.0f + curOffset,  0.0f,  4.0f));
	v = new Vector3(curOffset + 5.0f, 4.0f, 0.0f);
	mCurScene->addObject(new Pit(v, 8.0f, 4.0f, 20.0f));
	curOffset += 10;
   //----------------------------------------------------------------------


	// Scene 5
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	v = new Vector3(curOffset, 4.0f, 0.0f);
	mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									5.0f + curOffset,  0.0f,  4.0f));

	// Moving Spike 1
	Vector3 *start = new Vector3(curOffset - 2.5f, 0.0f, 3.5f);
	Vector3 *end = new Vector3(curOffset - 2.5f, 0.0f, -3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	// Moving Spike 2
	start = new Vector3(curOffset, 0.0f, -3.5f);
	end = new Vector3(curOffset, 0.0f, 3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	// Moving Spike 3
	start = new Vector3(curOffset + 2.5f, 0.0f, 3.5f);
	end = new Vector3(curOffset + 2.5f, 0.0f, -3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

   // Coins
   mCurScene->addObject(new Coin(-3.2f + curOffset, 0.75f, 2.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 2.0f));
   mCurScene->addObject(new Coin(-1.8f + curOffset, 0.75f, 2.0f));

   mCurScene->addObject(new Coin(-1.75f + curOffset, 0.75f, 0.0f));

   mCurScene->addObject(new Coin(-1.7f + curOffset, 0.75f, -2.0f));
   mCurScene->addObject(new Coin(-1.0f + curOffset, 0.75f, -2.0f));
   mCurScene->addObject(new Coin(-0.3f + curOffset, 0.75f, -2.0f));

   mCurScene->addObject(new Coin(0.2f + curOffset, 0.75f, 0.0f));

   mCurScene->addObject(new Coin(0.7f + curOffset, 0.75f, 2.0f));
   mCurScene->addObject(new Coin(1.4f + curOffset, 0.75f, 2.0f));
   mCurScene->addObject(new Coin(2.1f + curOffset, 0.75f, 2.0f));
   //----------------------------------------------------------------------

	
	// Scene 6
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	v = new Vector3(curOffset, 4.0f, 0.0f);
	mCurScene->addObject(new Cave(v, 4.0f, 10.0f));

	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									5.0f + curOffset,  0.0f,  4.0f));
	mCurScene->addObject(new Ground(-2.0f + curOffset, 1.0f, -3.0f,
									1.0f + curOffset,  2.0f,  -1.0f));
	mCurScene->addObject(new Ground(0.0f + curOffset, 3.0f, 1.0f,
									4.0f + curOffset,  4.0f,  4.0f));

   mCurScene->addObject(new Coin(-1.5f + curOffset, 2.75f, -2.0f));
   mCurScene->addObject(new Coin(-1.8f + curOffset, 2.75f, -2.0f));
   mCurScene->addObject(new Coin(-1.1f + curOffset, 2.75f, -2.0f));
   mCurScene->addObject(new Coin(0.7f + curOffset, 4.75f, 2.5f));
   mCurScene->addObject(new Coin(1.4f + curOffset, 4.75f, 2.5f));
   mCurScene->addObject(new Coin(2.1f + curOffset, 4.75f, 2.5f));
   //----------------------------------------------------------------------

	// Scene 7
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	v = new Vector3(curOffset, 4.0f, 0.0f);
	mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new Coin(-1.5f + curOffset, 1.75f, -2.2f));
   mCurScene->addObject(new Coin(0.7f + curOffset, 1.75f, 1.2f));
   mCurScene->addObject(new Coin(1.4f + curOffset, 2.75f, 0.0f));
   mCurScene->addObject(new Coin(2.1f + curOffset, 1.75f, -1.2f));

   mCurScene->addObject(new FlowSystem(-2.0f + curOffset, 0.0f, -4.0f,
                                        -1.0f + curOffset, 1.0f, -2.0f, ParticleSystem::texture[0]));
   mCurScene->addObject(new FlowSystem(0.5f + curOffset, 0.0f, -4.0f,
                                        1.5f + curOffset, 1.0f, -2.0f, ParticleSystem::texture[0]));

   mCurScene->addObject(new ParticleSystem( 2.0f + curOffset, 0.0f, 0.0f,
                                            3.0f + curOffset, 0.25f,  1.8f, 2000));
   mCurScene->addObject(new ParticleSystem(-2.5f + curOffset, 0.0f, 1.0f,
                                           -1.5f + curOffset, 0.25f,  2.8f, 2000));

	start = new Vector3(curOffset, 0.0f, -3.5f);
	end = new Vector3(curOffset, 0.0f, 3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	start = new Vector3(3.0f + curOffset, 0.0f, 3.5f);
	end = new Vector3(curOffset, 0.0f, 2.7f);
	mCurScene->addObject(new MovingSpike(start, end));

   mCurScene->addCharacter(new WalkingEnemy(-3.0f + curOffset, 0.5f, -1.3f));
   mCurScene->addCharacter(new WalkingEnemy(0.0f + curOffset, 0.5f, 1.0f));

   //----------------------------------------------------------------------


	// Scene 8
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	v = new Vector3(curOffset, 4.0f, 0.0f);
	mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new Ground(-2.8f + curOffset,  1.9f, -1.0f,
                                   -1.0f + curOffset,  2.3f,  1.0f));

   mCurScene->addObject(new Coin(0.7f + curOffset, 1.75f, 1.2f));
   mCurScene->addObject(new Coin(1.4f + curOffset, 2.75f, 0.0f));
   mCurScene->addObject(new Coin(2.1f + curOffset, 1.75f, -1.2f));

   mCurScene->addObject(new ParticleSystem( -2.0f + curOffset, 0.0f, -3.1f,
                                            3.0f + curOffset, 0.25f,  3.1f, 4500));
   //----------------------------------------------------------------------


	// Scene 9 - PIT SCENE
	curOffset += SCENE_WIDTH;
	mCurScene->mNextScene = new Scene(curOffset);
	mCurScene->mNextScene->mPrevScene = mCurScene;
	mCurScene = mCurScene->mNextScene;

	mCurScene->addObject(new Ground(4.0f + curOffset, -1.0f, -3.5f,
									7.0f + curOffset,  0.0f,  3.5f));
   mCurScene->addObject(new FallingPlatform(9.0f + curOffset, 0.0f, -0.75, 
                                          10.0f + curOffset, 0.5f, 0.75));
   mCurScene->addObject(new FallingPlatform(-2.0f + curOffset, 0.0f, -0.75, 
                                          -1.0f + curOffset, 0.5f, 0.75));
   mCurScene->addObject(new SwingingPlatform(-4.0f + curOffset, 1.0f, 0.0f,
                                             1.0f, 0.5f, 1.0f));

   mCurScene->addObject(new Coin(5.5f + curOffset, 1.75f, -2.2f));
   mCurScene->addObject(new Coin(5.5f + curOffset, 1.75f, -1.2f));

   mCurScene->addCharacter(new Boulder(7.3f + curOffset, 4.0f, 0.8f));

	v = new Vector3(curOffset + 5.0f, 4.0f, 0.0f);
	mCurScene->addObject(new Pit(v, 8.0f, 4.0f, 20.0f));
	curOffset += 10;
   //----------------------------------------------------------------------


   // Scene 10
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -1.0f));

   mCurScene->addCharacter(new Boulder(-3.2f + curOffset, 5.0f, -1.5f));
   mCurScene->addCharacter(new Boulder(2.6f + curOffset, 5.0f, 1.6f));

   //----------------------------------------------------------------------

   // Scene 11 - FIRE
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));

	// Moving Spike 1
	start = new Vector3(curOffset - 2.5f, 0.0f, 3.5f);
	end = new Vector3(curOffset - 2.5f, 0.0f, -3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	// Moving Spike 2
	start = new Vector3(curOffset + 2.5f, 0.0f, -3.5f);
	end = new Vector3(curOffset + 2.5f, 0.0f, 3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

   mCurScene->addObject(new Coin(-1.5f + curOffset, 1.75f, -2.2f));
   mCurScene->addObject(new Coin(0.7f + curOffset, 1.75f, 1.2f));
   mCurScene->addObject(new Coin(1.4f + curOffset, 2.75f, 0.0f));
   mCurScene->addObject(new Coin(2.1f + curOffset, 1.75f, -1.2f));

   mCurScene->addObject(new ParticleSystem( -1.5f + curOffset, 0.0f, -3.1f,
                                             1.5f + curOffset, 0.25f,  3.1f, 2500));
   //----------------------------------------------------------------------

   // Scene 12
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));

	// Moving Spike 1
	start = new Vector3(curOffset - 2.5f, 0.0f, 3.5f);
	end = new Vector3(curOffset - 2.5f, 0.0f, -3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	// Moving Spike 2
	start = new Vector3(curOffset, 0.0f, -3.5f);
	end = new Vector3(curOffset, 0.0f, 3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

	// Moving Spike 3
	start = new Vector3(curOffset + 2.5f, 0.0f, 3.5f);
	end = new Vector3(curOffset + 2.5f, 0.0f, -3.5f);
	mCurScene->addObject(new MovingSpike(start, end));

   // Moving Spike 4 
	start = new Vector3(curOffset - 2.5f, 0.0f, -1.75f);
	end = new Vector3(curOffset, 0.0f, -1.75f);
	mCurScene->addObject(new MovingSpike(start, end));

   // Moving Spike 5
	start = new Vector3(curOffset + 2.5f, 0.0f, 1.75f);
	end = new Vector3(curOffset, 0.0f, 1.75f);
	mCurScene->addObject(new MovingSpike(start, end));

   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -1.0f));
   //----------------------------------------------------------------------

   // Scene 13 - CRUSHING WALL
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new CrushingWall(curOffset, 5.0f, 0.0f, curOffset, 8.0f, 0.0f));

   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -1.0f));
   //----------------------------------------------------------------------

   // Scene 14
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));

   mCurScene->addObject(new CrushingWall(curOffset, 5.0f, -10.0f, curOffset, 5.0f, -5.0f));
   mCurScene->addObject(new CrushingWall(curOffset, 5.0f, 10.0f, curOffset, 5.0f, 5.0f));

   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-3.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(-2.5f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(1.0f + curOffset, 0.75f, -1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, 1.0f));
   mCurScene->addObject(new Coin(2.0f + curOffset, 0.75f, -1.0f));
   //----------------------------------------------------------------------

   // Scene 15
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

   v = new Vector3(curOffset, 4.0f, 0.0f);
   mCurScene->addObject(new Cave(v, 4.0f, 10.0f));
   mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
								   5.0f + curOffset,  0.0f,  4.0f));
   mCurScene->addObject(new ParticleSystem( -1.5f + curOffset, 0.0f, -3.1f,
                                             1.5f + curOffset, 0.25f,  3.1f, 2500));
   mCurScene->addCharacter(new PacingEnemy(-2.0f + curOffset, 0.75f, -2.5f, 5.0f));
   mCurScene->addCharacter(new PacingEnemy(2.0f + curOffset, 0.75f, 0.0f, 5.0f));
   mCurScene->addCharacter(new PacingEnemy(-2.0f + curOffset, 0.75f, 2.5f, 5.0f));
   //----------------------------------------------------------------------

   // Scene 16 - Final Scene!
   curOffset += SCENE_WIDTH;
   mCurScene->mNextScene = new Scene(curOffset);
   mCurScene->mNextScene->mPrevScene = mCurScene;
   mCurScene = mCurScene->mNextScene;

	mCurScene->addObject(new Ground(-5.0f + curOffset, -1.0f, -4.0f,
									15.0f + curOffset,  0.0f,  4.0f));

	v = new Vector3(curOffset + 5.0f, 4.0f, 0.0f);
	mCurScene->addObject(new Pit(v, 8.0f, 4.0f, 20.0f));
	curOffset += 10;


	// RESET CURSCENE TO FIRST
	mCurScene = mFirstScene;
}

void Stage2::display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	frameStart();
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glLoadIdentity();

		if (!(Stage::mPlayer.mState & ORTHO))
		{
			if (Stage::mPlayer.mState & CAMERABEHIND)
				gluLookAt(Stage::mPlayer.mPos[X] - 4.0, mCamera->mCameraY, Stage::mPlayer.mPos[Z],
				Stage::mPlayer.mPos[X],       mCamera->mLookAtY, Stage::mPlayer.mPos[Z],
				mCamera->mUpX,          mCamera->mUpY,     mCamera->mUpZ);

			else
				gluLookAt(Stage::mPlayer.mPos[X],       mCamera->mCameraY, mCamera->mCameraZ,
				Stage::mPlayer.mPos[X],        mCamera->mLookAtY, mCamera->mLookAtZ,
				mCamera->mUpX,          mCamera->mUpY,     mCamera->mUpZ);
		}
		else if (Stage::mPlayer.mState & ORTHO)
		{
			printf("Ortho camera\n");
			gluLookAt(Stage::mPlayer.mPos[X], 1, 5,
					  Stage::mPlayer.mPos[X], 0, 0,
									 0, 1, 0);
		}

		glDisable(GL_LIGHTING);
		if (mCurScene->mPrevScene)
			mCurScene->mPrevScene->draw();
		if (mCurScene->mNextScene)
			mCurScene->mNextScene->draw();
		mCurScene->draw();
		Stage::mPlayer.draw();

		//testEnemy->draw();
		//testBoulder->draw();

	glPopMatrix();
	frameEnd(GLUT_BITMAP_HELVETICA_12, 1.0f, 0.0f, 0.0f, 0, 0.95);
	glutSwapBuffers();
}

/* Checks the current state of the player and the
 * other objects in the stage 
 */
void Stage2::idle()
{
	mPrevTime.tv_sec = mCurTime.tv_sec;
	mPrevTime.tv_usec = mCurTime.tv_usec;
	gettimeofday(&mCurTime, NULL);


   if (Stage::mPlayer.mLife < 0.0f && mStageFlags & IMMORTAL) { // DIED ON GOD MODE

      Stage::mPlayer.mLife = 100.0f;
      Stage::mPlayer.mPos[Y] = 10.0;
      Stage::mPlayer.mMin[Y] = 9.5;
      Stage::mPlayer.mMax[Y] = 10.5;
      Stage::mPlayer.mVel[Y] = 0.0f;
   }
   else if (Stage::mPlayer.mLife < 0.0f) {                     // PLAYER HAS DIED
      if (Stage::mPlayer.mLives == 0) {                        // NO LIVES REMAINING,
         exit(0);                                        // GAME OVER
      }
      else {                                             // ELSE, RESTART
         Stage::mPlayer.mLives--;
         restartStage();
      }
   }
   else if (mCurScene->mOffset >= EOSSTAGE2) {      // STAGE COMPLETE!
      printf("Stage complete!\n");
      exit(0);
//      mStageFlags = STAGECOMPLETE;
   }
   else {
	   double dt = PASSED;
      Coin::gstep(dt);

	   if (Stage::mPlayer.mState & SPACEPRESSED)
		   Stage::mPlayer.jump();

	   Stage::mPlayer.mVel[X] = 0.0f;
	   Stage::mPlayer.mVel[Z] = 0.0f;

	   switch(mCurSpecial)
	   {
		   case GLUT_KEY_DOWN :                    // UP ARROW MOVES PLAYER UP
			   Stage::mPlayer.mVel[X] = -5.0f;
			   glutPostRedisplay();
			   break;
		   case GLUT_KEY_UP :                   // DOWN ARROW MOVES PLAYER DOWN
			   Stage::mPlayer.mVel[X] = 5.0f;
			   glutPostRedisplay();
			   break;
		   case GLUT_KEY_LEFT:
			   Stage::mPlayer.mVel[Z] = -5.0f;
			   glutPostRedisplay();
			   break;
		   case GLUT_KEY_RIGHT:
			   Stage::mPlayer.mVel[Z] = 5.0f;
			   glutPostRedisplay();
			   break;
		   default :
			   break;
	   }

	   Stage::mPlayer.step(dt, mCurScene);

	   mCurScene->step(dt);

	   if (mCurScene->mPrevScene)
		   mCurScene->mPrevScene->step(dt);
	   if (mCurScene->mNextScene)
		   mCurScene->mNextScene->step(dt);

	   if (mCurScene->mNextScene && Stage::mPlayer.mPos[X] >= mCurScene->mNextScene->mOffset - 5.0f)
		   mCurScene = mCurScene->mNextScene;
	   if (mCurScene->mPrevScene && Stage::mPlayer.mPos[X] < mCurScene->mOffset - 5.0f)
		   mCurScene = mCurScene->mPrevScene;
   }

   glutPostRedisplay();
}

void Stage2::initStage()
{
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(90, (double)World::wWidth / World::wHeight, .1, 20);

	glMatrixMode(GL_MODELVIEW);
		glViewport(0, 0, World::wWidth, World::wHeight);

   printf("INIT STAGE\n");
	gettimeofday(&mCurTime, NULL);
   mStageFlags = 0;
   mMusic = new MusicBox("stage2.xm");
   //Stage::mPlayer.reinitialize();
   Stage::mPlayer.mPos[X] = 0.0f;
   Stage::mPlayer.mPos[Y] = 20.0f;
   Stage::mPlayer.mPos[Z] = 0.0f;

   Stage::mPlayer.mMin[X] = -0.5f;
   Stage::mPlayer.mMin[Y] = 19.5f;
   Stage::mPlayer.mMin[Z] = -0.5f;

   Stage::mPlayer.mMax[X] = 0.5f;
   Stage::mPlayer.mMax[Y] = 20.5f;
   Stage::mPlayer.mMax[Z] = 0.5f;

   mMusic->PlayMusic();

   Stage::mPlayer.mState ^= CAMERABEHIND;	// Set to back-Stage::mPlayer.
   glutPostRedisplay();
}

void Stage2::restartStage() {
   #if defined(WIN32)
   PlaySound("death.wav", NULL, SND_FILENAME | SND_ASYNC);
   #endif

   for (Scene *curScene = mFirstScene; curScene; curScene = curScene->mNextScene) {
      for (std::vector<GameObject *>::iterator itr = curScene->mObjects.begin(); itr != curScene->mObjects.end(); itr++) {
         (*itr)->reinitialize();
      }
      for (std::vector<Character *>::iterator itr = curScene->mFoes.begin(); itr != curScene->mFoes.end(); itr++) {
         (*itr)->reinitialize();
      }
   }

   Stage::mPlayer.reinitialize();

   Stage::mPlayer.mPos[X] = 0.0;
   Stage::mPlayer.mPos[Y] = 10.0;
   Stage::mPlayer.mPos[Z] = 0.0;

   Stage::mPlayer.mMin[X] = -0.5;
   Stage::mPlayer.mMin[Y] = 9.5;
   Stage::mPlayer.mMin[Z] = -0.5;

   Stage::mPlayer.mMax[X] = 0.5;
   Stage::mPlayer.mMax[Y] = 10.5;
   Stage::mPlayer.mMax[Z] = 0.5;

   mCurScene = mFirstScene;
}

void Stage2::keyboard(unsigned char key, int x, int y)
{
   mCurKey = key;

   switch (key)
   {
      case ' ' :
         Stage::mPlayer.mState |= SPACEPRESSED;
         break;
      case 'c' : case 'C' :                     // TOGGLE THE CAMERA
         Stage::mPlayer.mState ^= CAMERABEHIND;
         break;
      case 'g' : case 'G' :                     // TOGGLE IMMORTAL MODE
         printf("IMMORTAL MODE\n");
         mStageFlags ^= IMMORTAL;
         break;
      case 'o' : case 'O' :                     // TOGGLE ORTHOGRAPHIC PROJECTION --DISABLED--
         Stage::mPlayer.mState ^= ORTHO;
         printf("Orthographic Projection is %d\n", Stage::mPlayer.mState & ORTHO);
         glutPostRedisplay();
         break;
      case 'q' : case 'Q' :                     // QUIT THE GAME
         exit(0);
         break;
      case 'r' : case 'R' :                     // RESET THE GAME
         restartStage();
         break;
      default :
         break;
   }
}

void Stage2::keyboardUp(unsigned char key, int x, int y)
{
	if (key == ' ')
	{
		Stage::mPlayer.mState &= ~SPACEPRESSED;
		Stage::mPlayer.stopJump();
	}
	mCurKey = 0;
}

void Stage2::reshape(int width, int height)
{
	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();

		if (Stage::mPlayer.mState & ORTHO)
			glOrtho(-5.0, 6.0, -1.0, 5.0, -1, 1);
		else
			gluPerspective(90, (double)width / height, .1, 20);

	glMatrixMode(GL_MODELVIEW);
		glViewport(0, 0, width, height);

	glutPostRedisplay();
}

void Stage2::special(int key, int x, int y)
{
	/* REMOVED TO ALLOW Z-AXIS MOVEMENT */
	//if (key == GLUT_KEY_LEFT)
	//	Stage::mPlayer.mState |= UPPRESSED;
	//else
		mCurSpecial = key;
}

void Stage2::specialUp(int key, int x, int y)
{
	/* REMOVED TO ALLOW Z-AXIS MOVEMENT */
	//if (key == GLUT_KEY_LEFT)
	//	Stage::mPlayer.mState &= ~UPPRESSED;
	//else
		mCurSpecial = 0;
}

void Stage2::frameEnd(void *font, GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y)
{
  /* font: font to use, e.g., GLUT_BITMAP_HELVETICA_10
     r, g, b: text colour
     x, y: text position in window: range [0,0] (bottom left of window)
           to [1,1] (top right of window). */

   float elapsedTime; 
   char str[40]; 
   char *ch; 
   GLint matrixMode;
   GLboolean lightingOn;

   gettimeofday(&frameEndTime, NULL);
   elapsedTime = ELAPSED;

   lightingOn = glIsEnabled(GL_LIGHTING);        /* lighting on? */

   if (lightingOn)
       glDisable(GL_LIGHTING);

   glGetIntegerv(GL_MATRIX_MODE, &matrixMode);  /* matrix mode? */

   glMatrixMode(GL_PROJECTION);
   glPushMatrix();
   glLoadIdentity();
      gluOrtho2D(0.0, 1.0, 0.0, 1.0);
      glMatrixMode(GL_MODELVIEW);

      glPushMatrix();
      glLoadIdentity();   
         glPushAttrib(GL_COLOR_BUFFER_BIT);       /* save current colour */
         glColor3f(r, g, b);

         sprintf(str, "Frames per second: %2.0f", 1.0 / elapsedTime);
         glRasterPos3f(x, y, 0.0);

         for(ch = str; *ch; ch++) {
            glutBitmapCharacter(font, (int)*ch);
         }

         sprintf(str, "Life: %2.0f", Stage::mPlayer.getLife());
         glRasterPos3f(x, y - 0.05, 0.0);

         for(ch = str; *ch; ch++) {
            glutBitmapCharacter(font, (int)*ch);
         }

         sprintf(str, "Lives: %d", Stage::mPlayer.mLives);
         glRasterPos3f(x, y - 0.10f, 0.0);

         for(ch = str; *ch; ch++) {
            glutBitmapCharacter(font, (int)*ch);
         }

         sprintf(str, "Coins: %d", Stage::mPlayer.mCoins);
         glRasterPos3f(x, y - 0.15f, 0.0);

         for(ch = str; *ch; ch++) {
            glutBitmapCharacter(font, (int)*ch);
         }

         glPopAttrib();
      glPopMatrix();
      glMatrixMode(GL_PROJECTION);
   glPopMatrix();

   glMatrixMode(matrixMode);
   if (lightingOn)
      glEnable(GL_LIGHTING);
}