#ifndef _STAGE2_H_
#define _STAGE2_H_

#include <stdio.h>
#include <iostream>
#include "MusicBox.h"
#include "Stage.h"
#include "Scene.h"

#include "Player.h"
#include "Camera.h"
#include "Coin.h"
#include "Boulder.h"

#include "Pit.h"
#include "Cave.h"
#include "Ground.h"
#include "Inset.h"
#include "Platform.h"
#include "FallingPlatform.h"
#include "HorizontalPlatform.h"
#include "SwingingPlatform.h"
#include "MovingSpike.h"
#include "CrushingWall.h"

#include "ParticleSystem.h"
#include "FlowSystem.h"
#include "WalkingEnemy.h"
#include "PacingEnemy.h"

#include "Constants.h"

class Stage2 : public Stage
{
private:
   struct timeval mPrevTime, mCurTime, mStartTime;
   struct timeval frameStartTime, frameEndTime;

//   Player *mPlayer;
   Camera *mCamera;
   Scene *mCurScene, *mFirstScene;

   //WalkingEnemy *testEnemy;
   //Boulder *testBoulder;

   MusicBox *mMusic;

   unsigned char mCurKey;
   unsigned char mStageFlags;
   int mCurSpecial;

   void restartStage();

public:
   Stage2();
   virtual ~Stage2();

   void display();
   void idle();
   void keyboard(unsigned char key, int x, int y);
   void keyboardUp(unsigned char key, int x, int y);
   void reshape(int x, int y);
   void special(int key, int x, int y);
   void specialUp(int key, int x, int y);

   void initScenes();
   void initStage();
   inline void frameStart() {gettimeofday(&frameStartTime, NULL);}
   void frameEnd(void *font, GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y);
};

#endif