#ifndef _SWINGINGPLATFORM_H_
#define _SWINGINGPLATFORM_H_

#include <iostream>
#include <math.h>
#include "GameObject.h"
#include "Character.h"

class SwingingPlatform : public GameObject {
protected:
   float currFrame;
   float increment;
   float mAngle;
   float mTime;
//   float mEndPos[3], mTrans[3];
   float mCenter[3];

   // Texture mapping variable
   static Image *TextureImage;

public:
   SwingingPlatform(float posx, float posy, float posz, float width, float height, float depth);
   virtual ~SwingingPlatform();

   void collide(Character *character, double *dx, double *dy, double *dz);
   void draw();
   void reinitialize();
   void step(double dt);

   static int ImageLoad(char *filename, Image *image);
   static GLvoid LoadTexture(char* image_file, int tex_id);
};

#endif